
-- # import logic
-- # import id
-- # import eqchain
-- # import nat
-- # import acc

DivMod : Nat -> Nat -> Prop
DivMod n m = Exist $ \(q,r) -> r < m  /\  n == r + q * m

divMod : (n,m:Nat) -> (0 < m) -> DivMod n m
divMod n' m "0<m" = divMod' n' (accessible n') (trich n' m)
    where
      divMod' : (n:Nat) -> Acc n -> Trich n m -> DivMod n m
      divMod' n _ (less  "n<m") = (0,n) `witness` andI "n<m" refl
      divMod' n _ (equal "n=m") = (1,0) `witness`
				    andI "0<m"
					 fol-plugin(plusZero,"n=m")
      divMod' n (acc h) (greater "n>m") = step ih
	where

	  ih : DivMod (n - m) m
	  ih = divMod' (n - m) rem (trich (n - m) m)
	    where
	      rem : Acc (n - m)
	      rem = h (n - m) (minusLess n m "n>m" "0<m")


	  step : DivMod (n - m) m -> DivMod n m
	  step ((q,r) `witness` andI "r<m" "n-m=r+q*m") =
	    (suc q,r) `witness`
	      andI "r<m"
		   (eqChain
		    n === n - m + m	`since` minusPlus n m (orIL "n>m")
		      === r + (suc q * m)
			`since` fol-plugin("n-m=r+q*m",plusCommute,plusAssoc)
		   )

logDivMod : (n,m:Nat) -> (0 < m) -> DivMod n m
logDivMod n' m "0<m" = assert-plugin()

mod : Nat -> Nat -> Nat
mod n  0      = 0
mod n (suc m) = getr (divMod n (suc m) (zeroLessSuc m))
  where
    getr : DivMod n (suc m) -> Nat
    getr (witness (_,r) _) = r


div : Nat -> Nat -> Nat
div n  0      = 0
div n (suc m) = getq (divMod n (suc m) (zeroLessSuc m))
  where
    getq : DivMod n (suc m) -> Nat
    getq (witness (q,_) _) = q

