
data (==) {A:Set}(a:A) : A -> Set where
  refl : a == a

infixr 15 ::, ++

data List (A : Set) : Set where
  nil  : List A
  (::) : A -> List A -> List A

(++) (A:Set) : List A -> List A -> List A
[]	++ ys = ys
(x::xs) ++ ys = x :: (xs ++ ys)

rotate (A:Set) : List A -> List A
rotate []      = []
rotate (x::xs) = xs ++ [x]

data Bit : Set where
  O : Bit
  I : Bit

neg : Bit -> Bit
neg O = I
neg I = O

negNegId : (x : Bit) -> neg (neg x) == x
negNegId O = refl
negNegId I = refl

rewrite negNegId

data Alternating : Bit -> List Bit -> Set where
  altCns (x : Bit)(xs : List Bit) : Alternating (neg x) xs -> Alternating x (x::xs)
  altNil (x:Bit)		  : Alternating x []

data Paired : List Bit -> Set where
  pairCons (x : Bit)(xs : List Bit) : Paired xs -> Paired (x :: neg x :: xs)
  pairUnit (x : Bit)		    : Paired [x]
  pairNil			    : Paired []

data Shuffle {A:Set} : List A -> List A -> List A -> Set where
  shuffle1 (x:A)(xs,ys,zs:List A) : Shuffle xs ys zs -> Shuffle (x::xs) ys (x::zs)
  shuffle2 (y:A)(xs,ys,zs:List A) : Shuffle xs ys zs -> Shuffle xs (y::ys) (y::zs)
  shuffleNil			  : Shuffle {A} [] [] []

data Even {A:Set} : List A -> Set where
  evenNil : Even {A} []
  evenCC (x,y:A)(xs:List A) : Even xs -> Even (x::y::xs)

data Opposite : List Bit -> List Bit -> Set where
  opp (x:Bit)(xs,ys:List Bit) : Opposite (x::xs) (neg x::ys)

