
data Empty : Set where

data AlsoEmpty : Set where
  empty : Empty -> AlsoEmpty

data AlsoEmpty₂ : Set where
  empty₁ : Empty -> AlsoEmpty₂
  empty₂ : Empty -> AlsoEmpty₂

X : Set
x : X

f : Empty -> X
f ()

f₁ : AlsoEmpty -> X
f₁ (empty ())

f₂ : AlsoEmpty₂ -> X
f₂ (empty₁ ())
f₂ (empty₂ ())

data Nat : Set where
  zero : Nat
  suc  : Nat -> Nat

data List (a : Set) : Set where
  nil  : List a
  (::) : a -> List a -> List a

map (a,b : Set) : (a -> b) -> List a -> List b
map g []      = []
map g (y :: ys) = g y :: map g ys

data Even : Nat -> Set where
  even0		 : Even 0
  evenSS (n : Nat) : Even n -> Even (suc (suc n))

g₁ : (n : Nat) -> Even n -> X
g₁  0		  even0	     = x
g₁ (suc 0)	 ()
g₁ (suc (suc n)) (evenSS en) = g₁ n en

data Bool : Set where
  false, true : Bool

(&&) : Bool -> Bool -> Bool
false && _     = false
_     && false = false
true  && true  = true

maj : Bool -> Bool -> Bool -> Bool
maj true  true	true  = true
maj true  false b     = b
maj false b	true  = b
maj b	  true	false = b
maj false false false = false

data Vec (a : Set) : Nat -> Set where
  vnil	        : Vec a 0
  vcons (n : Nat) : a -> Vec a n -> Vec a (suc n)

zip (a,b : Set) : (n : Nat) -> Vec a n -> Vec b n -> Vec {a;b} n
zip _  vnil	    vnil	= vnil
zip _ (vcons y ys) (vcons z zs) = (y,z) `vcons` zip _ ys zs

unzip (a,b : Set) : List {a;b} -> {List a;List b}
unzip []  = ([],[])
unzip ((y,z) :: yzs) with unzip yzs =>
  _ ((y,z) :: yzs) (ys,zs) = (y :: ys,z :: zs)

tail (a : Set)(n : Nat) : Vec a (suc n) -> Vec a n
tail (vcons _ xs) = xs

data (==){A : Set}(a : A) : A -> Set where
  refl : a == a

sucNotZero (A : Set)(n : Nat) : suc n == 0 -> A
sucNotZero ()

tail₃ (a : Set)(n : Nat) : Vec a (suc (suc (suc n))) -> Vec a n
tail₃ (vcons _ (vcons _ (vcons _ xs))) = xs

g₂ : (n : Nat) -> Even n -> X
g₂  0		  even0	     = x
g₂ (suc (suc n)) (evenSS en) = g₁ n en

