
-- # import nat

data Fin : Nat -> Set where
  fzero	(n : Nat) : Fin (suc n)
  fsuc  (n : Nat) : Fin n -> Fin (suc n)

thin (n : Nat) : Fin (suc n) -> Fin n -> Fin (suc n)
thin fzero    i		= fsuc i
thin (fsuc i) fzero	= fzero
thin (fsuc i) (fsuc j)	= fsuc (thin i j)

data ThinView : (n : Nat) -> Fin n -> Fin n -> Set where
  hit  (n : Nat)(i : Fin n)	  : ThinView n i i
  miss (n : Nat)(i : Fin (suc n)) : (j : Fin n) -> ThinView (suc n) i (thin i j)

thinView (n : Nat) : (i, j : Fin n) -> ThinView n i j
thinView fzero		 fzero	  = hit
thinView fzero		 (fsuc j) = miss j
thinView (fsuc fzero)	 fzero	  = miss fzero	-- slightly annoying split
thinView (fsuc (fsuc i)) fzero	  = miss fzero	-- but nothing to do with inductive families
thinView (fsuc i)	 (fsuc j) with thinView i j =>
  _	 (fsuc i) (fsuc i)          hit	     = hit
  _	 (fsuc i) (fsuc (thin i j)) (miss j) = miss (fsuc j)

